from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.CMFCore.utils import getToolByName

from Products.EventRegistration.utils import getPropSheet

from Products.EventRegistration.config import PROJECTNAME
from Products.EventRegistration.config import GLOBALS
from Products.EventRegistration.config import EVENT_LOCATIONS
from Products.EventRegistration.config import HONORIFICS
from Products.EventRegistration.config import PROPSHEET_NAME

from StringIO import StringIO



def setupProperties(self, out):
	# install site properties
	ps = getPropSheet(self, PROPSHEET_NAME, out = out)
	ps._properties = ps._properties + ( 
			{'id':'event_locations', 'type':'lines', 'mode':'w'},
			{'id':'honorifics', 'type':'lines', 'mode':'w'},
		)
	ps._updateProperty('event_locations', EVENT_LOCATIONS)
	ps._updateProperty('honorifics', HONORIFICS)
	print >> out, 'Added default properties on %s.' % PROPSHEET_NAME

def removePropSheet(self, out):
	ptool = getToolByName(self, 'portal_properties', None)
	ptool.manage_delObjects(PROPSHEET_NAME)
	print >> out, 'Removing %s from portal_properties.' % PROPSHEET_NAME

def subskinInstall(self, out):
	install_subskin(self, out, GLOBALS)

def archetypesInstall(self, out):
	installTypes(self, 
			out,
			listTypes(PROJECTNAME),
			PROJECTNAME
			)
	print >> out, "Installed content types:"
	for t in listTypes(PROJECTNAME):
		print >> out, '--  %s' % t['name']

def useFactory(self, out):
	'''sets all types to use portal_factory -- why isn't this default in plone?????'''
	ttool = getToolByName(self, 'portal_types')
	ftool = getToolByName(self, 'portal_factory')
	all_types = ttool.listContentTypes()
	types = []
	for t in all_types:
		if not t == 'Registrant':
			types += [t]
	ftool.manage_setPortalFactoryTypes(listOfTypeIds = types)
	print >> out, 'Set all types to use portal_factory -- NB: this will NOT be reverted by uninstall.'

def setupWorkflows(self, out):
	wft = getToolByName(self, 'portal_workflow')
	wft.manage_addWorkflow(id = 'event_workflow',
			workflow_type = 'event_workflow (Event Workflow)'
			)
	wft.manage_addWorkflow(id = 'registrant_workflow',
			workflow_type = 'registrant_workflow (Registrant Workflow)'
			)
	wft.setChainForPortalTypes( ('Event',), 'event_workflow')
	wft.setChainForPortalTypes( ('Registrant',), 'registrant_workflow')
	print >> out, 'Set up "Event Workflow" and "Registrant Workflow"'



#
# INSTALL
#

def install(self):
	out = StringIO()
	archetypesInstall(self, out)
	subskinInstall(self, out)
	setupProperties(self, out)
	setupWorkflows(self, out)
	useFactory(self, out)
	return out.getvalue()

def uninstall(self):
	out = StringIO()
	removePropSheet(self, out)
	print >> out, 'For now, at least, uninstall does nothing but remove the %s property sheet.' % PROPSHEET_NAME
	return out.getvalue()
