##########################################################################
#                                                                        #
#     Based on my_utils.py from Raphael Ritz's excellent "MySite"        #
#     tutorial (http://www.neuroinf.de/PloneDevTutorial), which is       #
#     copyright (c) 2004 ITB, Humboldt-University Berlin, and is used    #
#     in EventRegistration by permission of the author.                  #
#                                                                        #
##########################################################################

""" utilities for EventRegistration """

from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import DisplayList
from StringIO import StringIO

from Products.EventRegistration.config import PROJECTNAME

def getValues(self, prop_name):
    ptool = getToolByName(self, 'portal_properties', None)
    if ptool and hasattr(ptool, 'event_registration_properties'):
        prop = ptool.event_registration_properties.getProperty(prop_name, None)
        return prop
    else:
        return None
    
def makeDisplayList(values=None):
    if values and type(values) not in [type([]), type(())]:
        values = (values,)
    if not values: values = []
    results = [['','Select']]
    for x in values:
        results.append([x,x])
    values_tuple = tuple(results)
    return DisplayList(values_tuple)

def getDisplayList(self, prop_name=None):
    return makeDisplayList(getValues(self, prop_name))

#
# End of my_utils.py derived portion
#

def getPropSheet(self, sheet_name, out=None, title=None):
	'''
	Returns the property sheet named by sheet_name.  Optional argument "out"
	specifies where debug messages will be written.  Optional string argument
	"title" is used to supply a title if a new prop sheet is created.
	'''
	if not out: # send debug messages to nowhere
		out = StringIO() 
	if not title:
		title = 'Properties for %s product' % PROJECTNAME
	ptool = getToolByName(self, 'portal_properties')
	psheet = getattr(ptool, sheet_name, None)
	if psheet:
		print >> out, 'Found existing %s property sheet.' % sheet_name
	else:
		ptool.addPropertySheet(sheet_name, title)
		print >> out, 'Created %s property sheet.' % sheet_name
	propsheet = getattr(ptool, sheet_name)
	return propsheet
