#from Products.PythonScripts.PythonScript import PythonScript

from Products.CMFCore.CMFCorePermissions import ModifyPortalContent
#from Products.CMFCore.CMFCorePermissions import View
#from Products.CMFCore.CMFCorePermissions import AccessContentsInformation
from Products.CMFCore.CMFCorePermissions import AddPortalContent

#from Products.CMFCalendar.EventPermissions import ChangeEvents

from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.DCWorkflow.Default import setupDefaultWorkflowRev2


def configureEventPermissions(wf):
	'''allow anonymous users to add content to (folderish) Events'''
	wf.permissions += (AddPortalContent,)
	wf.states.visible.permission_roles[AddPortalContent]=('Manager', 'Member', 'Anonymous')
	wf.states.pending.permission_roles[AddPortalContent]=('Manager', 'Member', 'Anonymous')
	wf.states.published.permission_roles[AddPortalContent]=('Manager', 'Member', 'Anonymous')

def configureRegistrantPermissions(wf):
	'''allow anonymous users edit Registrant objects'''
	wf.states.visible.permission_roles[ModifyPortalContent]=('Manager', 'Member', 'Anonymous')
	wf.states.pending.permission_roles[ModifyPortalContent]=('Manager', 'Member', 'Anonymous')
	wf.states.published.permission_roles[ModifyPortalContent]=('Manager', 'Member', 'Anonymous')

def createEventWorkflow(id):
	ob = DCWorkflowDefinition(id)
	setupDefaultWorkflowRev2(ob)
	ob.setProperties(title = 'Event Workflow')
	configureEventPermissions(ob)
	return ob

def createRegistrantWorkflow(id):
	ob = DCWorkflowDefinition(id)
	setupDefaultWorkflowRev2(ob)
	ob.setProperties(title = 'Registrant Workflow')
	configureRegistrantPermissions(ob)
	return ob

addWorkflowFactory(createEventWorkflow, id = 'event_workflow', title='Event Workflow')
addWorkflowFactory(createRegistrantWorkflow, id = 'registrant_workflow', title='Registrant Workflow')
